﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Models.Events;
using Models.Rules;

namespace Models.Game
{
    public class Game
    {
        public Player CurrentPlayer { get; private set; }

        public Map UsedMap { get; private set; }

        private Dice Dice1 { get; }
        private Dice Dice2 { get; }

        private int Turn { get; set; }

        private Rules.Rules GameRules { get; }

        // == Events ==
        public event GameStartedEventArgs OnGameStarted;

     
        public Game(Player player, Map map)
        {
            UsedMap = map;
            CurrentPlayer = player;
            Dice1 = new Dice();
            Dice2 = new Dice(1);
            Turn = 0;
            GameRules = new Rules.Rules();
        }

        public void RollAllDice()
        {
            Dice1.Roll();
            Dice2.Roll();
        }

        public int ResultOperation(Operation o)
        {
            switch (o)
            {
                case Operation.LOWER:
                    return Dice1.IsLower(Dice2) ? Dice1.Value : Dice2.Value;

                case Operation.HIGHER:
                    return Dice1.IsLower(Dice2) ? Dice2.Value : Dice1.Value;

                case Operation.SUBTRACTION:
                    return Dice1.IsLower(Dice2) ? Dice2.Value - Dice1.Value : Dice1.Value - Dice2.Value;

                case Operation.ADDITION:
                    return Dice2.Value + Dice1.Value;

                case Operation.MULTIPLICATION:
                    return Dice2.Value * Dice1.Value;
                
                default:
                    return 0;
            }
        }

        public void PlaceResult (Cell playerChoice, int result)
        {
            if (Turn == 1 || GameRules.NearCell(playerChoice, UsedMap.Boards))
            {
                playerChoice.Value = result;
            }
        }

        public void AddToRopePath(Cell playerChoice, List<Cell> adjacentes, List<List<Cell>> ropePaths)
        {

            // Parmi les {adjacentes} garde seulement les cellules qui peuvent creer un chemin de corde
            foreach (var item in adjacentes)
            {
                if (item.Value == playerChoice.Value && ((playerChoice.Value - item.Value) > 1 || (playerChoice.Value - item.Value) < -1)) adjacentes.Remove(item);
            }

            // Apres le foreach si la liste {adjacentes} est vide, plus aucune possiblite de creer ou d'ajouter a un chemin de corde
            if (adjacentes.Count == 0) return;

            // Si {ropePaths} est vide, il faut alors creer un chemin de corde entre {playerChoice} et une cellule {d'adjacentes}
            if (ropePaths.Count == 0)
            {
                // Deux cas de figure soit la liste {adjacentes} contient une seul valeur soit plusieurs

                // Si {adjacentes} contient une valeur, ajouter dans ropePaths un nouveau chemin de corde

                // Si {adjacentes} contient plusieurs valeurs, permettre aux joueurs de choisir la cellule pour creer un nouveau chemin de corde
            }

            foreach (var item in adjacentes)
            {
                foreach (var item1 in ropePaths)
                {
                    foreach (var item2 in item1)
                    {

                    }
                }
            }
        }

    }
}
